--- include/class.user.php	2009-01-22 12:19:07.582949508 +0200
+++ /usr/share/eventum/include/class.user.php	2009-02-05 02:15:18.670659468 +0200
@@ -29,20 +29,10 @@
 // @(#) $Id: class.user.php 3808 2009-01-22 10:20:10Z glen $
 //
 
-require_once(APP_INC_PATH . "class.error_handler.php");
-require_once(APP_INC_PATH . "class.auth.php");
-require_once(APP_INC_PATH . "class.mail.php");
-require_once(APP_INC_PATH . "class.misc.php");
-require_once(APP_INC_PATH . "class.prefs.php");
-require_once(APP_INC_PATH . "class.notification.php");
-require_once(APP_INC_PATH . "class.validation.php");
-require_once(APP_INC_PATH . "class.date.php");
-require_once(APP_INC_PATH . "class.project.php");
-require_once(APP_INC_PATH . "class.setup.php");
 require_once(APP_CONFIG_PATH . "private_key.php");
 
 // definition of roles
-$roles = array(
+$GLOBALS['roles'] = array(
     1 => "Viewer",
     2 => "Reporter",
     3 => "Customer",
@@ -78,7 +68,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "user
                  WHERE
                     usr_customer_contact_id=" . Misc::escapeInteger($customer_contact_id);
-        $res = $GLOBALS["db_api"]->dbh->getOne($stmt);
+        $res = Db_Helper::getInstance()->getOne($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return '';
@@ -104,7 +94,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "user
                  WHERE
                     usr_customer_contact_id=" . Misc::escapeInteger($customer_contact_id);
-        $res = $GLOBALS["db_api"]->dbh->getOne($stmt);
+        $res = Db_Helper::getInstance()->getOne($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return '';
@@ -130,7 +120,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "user
                  WHERE
                     usr_id=" . Misc::escapeInteger($usr_id);
-        $res = $GLOBALS["db_api"]->dbh->getOne($stmt);
+        $res = Db_Helper::getInstance()->getOne($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return '';
@@ -157,7 +147,7 @@
                     usr_sms_email='" . Misc::escapeString($sms_email) . "'
                  WHERE
                     usr_id=" . Misc::escapeInteger($usr_id);
-        $res = $GLOBALS["db_api"]->dbh->query($stmt);
+        $res = Db_Helper::getInstance()->query($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return false;
@@ -183,7 +173,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "user
                  WHERE
                     usr_id=" . Misc::escapeInteger($usr_id);
-        $res = $GLOBALS["db_api"]->dbh->getOne($stmt);
+        $res = Db_Helper::getInstance()->getOne($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return -1;
@@ -215,7 +205,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "user
                  WHERE
                     usr_id=" . Misc::escapeInteger($usr_id);
-        $res = $GLOBALS["db_api"]->dbh->getOne($stmt);
+        $res = Db_Helper::getInstance()->getOne($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return -1;
@@ -241,7 +231,7 @@
                     usr_status='active'
                  WHERE
                     usr_email='" . Misc::escapeString($email) . "'";
-        $res = $GLOBALS["db_api"]->dbh->query($stmt);
+        $res = Db_Helper::getInstance()->query($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return false;
@@ -269,7 +259,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "user
                  WHERE
                     usr_email='" . Misc::escapeString($email) . "'";
-        $res = $GLOBALS["db_api"]->dbh->getOne($stmt);
+        $res = Db_Helper::getInstance()->getOne($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return -1;
@@ -314,14 +304,14 @@
                     usr_preferences,
                     usr_status
                  ) VALUES (
-                    '" . Date_API::getCurrentDateGMT() . "',
+                    '" . Date_Helper::getCurrentDateGMT() . "',
                     '" . Auth::hashPassword(Misc::escapeString($_POST["passwd"])) . "',
                     '" . Misc::escapeString($_POST["full_name"]) . "',
                     '" . Misc::escapeString($_POST["email"]) . "',
                     '" . Misc::escapeString($prefs) . "',
                     'pending'
                  )";
-        $res = $GLOBALS["db_api"]->dbh->query($stmt);
+        $res = Db_Helper::getInstance()->query($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return -1;
@@ -334,7 +324,7 @@
             // send confirmation email to user
             $hash = md5($_POST["full_name"] . md5($_POST["email"]) . $GLOBALS["private_key"]);
 
-            $tpl = new Template_API;
+            $tpl = new Template_Helper();
             $tpl->setTemplate('notifications/visitor_account.tpl.text');
             $tpl->bulkAssign(array(
                 "app_title"   => Misc::getToolCaption(),
@@ -344,7 +334,7 @@
             $text_message = $tpl->getTemplateContents();
 
             $setup = Setup::load();
-            $mail = new Mail_API;
+            $mail = new Mail_Helper;
             // need to make this message MIME based
             $mail->setTextBody($text_message);
             $mail->send($setup["smtp"]["from"], $_POST["email"], APP_SHORT_NAME . ": New Account - Confirmation Required");
@@ -367,7 +357,7 @@
         // send confirmation email to user
         $hash = md5($info["usr_full_name"] . md5($info["usr_email"]) . $GLOBALS["private_key"]);
 
-        $tpl = new Template_API;
+        $tpl = new Template_Helper();
         $tpl->setTemplate('notifications/password_confirmation.tpl.text');
         $tpl->bulkAssign(array(
             "app_title" => Misc::getToolCaption(),
@@ -377,7 +367,7 @@
         $text_message = $tpl->getTemplateContents();
 
         $setup = Setup::load();
-        $mail = new Mail_API;
+        $mail = new Mail_Helper;
         // need to make this message MIME based
         $mail->setTextBody($text_message);
         $mail->send($setup["smtp"]["from"], $info["usr_email"], APP_SHORT_NAME . ": New Password - Confirmation Required");
@@ -434,7 +424,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "user
                  WHERE
                     usr_email='" . Misc::escapeString($email) . "'";
-        $res = $GLOBALS["db_api"]->dbh->getOne($stmt);
+        $res = Db_Helper::getInstance()->getOne($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return "";
@@ -531,7 +521,7 @@
         $stmt .= "
                  ORDER BY
                     usr_full_name ASC";
-        $res = $GLOBALS["db_api"]->dbh->getAssoc($stmt);
+        $res = Db_Helper::getInstance()->getAssoc($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return "";
@@ -645,7 +635,7 @@
                  WHERE
                     pru_usr_id=" . Misc::escapeInteger($usr_id) . " AND
                     pru_prj_id = " . Misc::escapeInteger($prj_id);
-        $res = $GLOBALS["db_api"]->dbh->getOne($stmt);
+        $res = Db_Helper::getInstance()->getOne($stmt);
         if (PEAR::isError($res)) {
             return "";
         } else {
@@ -676,7 +666,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "user
                  WHERE
                     usr_id=" . Misc::escapeInteger($usr_id);
-        $res = $GLOBALS["db_api"]->dbh->getRow($stmt, DB_FETCHMODE_ASSOC);
+        $res = Db_Helper::getInstance()->getRow($stmt, DB_FETCHMODE_ASSOC);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return "";
@@ -728,9 +718,9 @@
                  WHERE
                     usr_id IN (" . implode(', ', Misc::escapeInteger($items)) . ")";
         if (!is_array($usr_id)) {
-            $res = $GLOBALS["db_api"]->dbh->getOne($stmt);
+            $res = Db_Helper::getInstance()->getOne($stmt);
         } else {
-            $res = $GLOBALS["db_api"]->dbh->getCol($stmt);
+            $res = Db_Helper::getInstance()->getCol($stmt);
         }
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
@@ -779,9 +769,9 @@
                  WHERE
                     usr_id IN (" . implode(', ', Misc::escapeInteger($items)) . ")";
         if (!is_array($usr_id)) {
-            $res = $GLOBALS["db_api"]->dbh->getOne($stmt);
+            $res = Db_Helper::getInstance()->getOne($stmt);
         } else {
-            $res = $GLOBALS["db_api"]->dbh->getCol($stmt);
+            $res = Db_Helper::getInstance()->getCol($stmt);
         }
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
@@ -826,9 +816,9 @@
                  WHERE
                     usr_id IN (" . implode(', ', Misc::escapeInteger($items)) . ")";
         if (!is_array($usr_id)) {
-            $res = $GLOBALS["db_api"]->dbh->getOne($stmt);
+            $res = Db_Helper::getInstance()->getOne($stmt);
         } else {
-            $res = $GLOBALS["db_api"]->dbh->getCol($stmt);
+            $res = Db_Helper::getInstance()->getCol($stmt);
         }
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
@@ -861,7 +851,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "user
                  WHERE
                     usr_email='" . Misc::escapeString($email) . "'";
-        $res = $GLOBALS["db_api"]->dbh->getOne($stmt);
+        $res = Db_Helper::getInstance()->getOne($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return '';
@@ -888,7 +878,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "user
                  WHERE
                     usr_status='active'";
-        $total_active = $GLOBALS["db_api"]->dbh->getOne($stmt);
+        $total_active = Db_Helper::getInstance()->getOne($stmt);
         if (($total_active < 2) && ($_POST["status"] == "inactive")) {
             return false;
         }
@@ -900,7 +890,7 @@
                     usr_status='" . $_POST["status"] . "'
                  WHERE
                     usr_id IN ($items)";
-        $res = $GLOBALS["db_api"]->dbh->query($stmt);
+        $res = Db_Helper::getInstance()->query($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return false;
@@ -929,7 +919,7 @@
                     usr_password='" . Auth::hashPassword($_POST["new_password"]) . "'
                  WHERE
                     usr_id=" . Misc::escapeInteger($usr_id);
-        $res = $GLOBALS["db_api"]->dbh->query($stmt);
+        $res = Db_Helper::getInstance()->query($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return -1;
@@ -957,7 +947,7 @@
                     usr_full_name='" . Misc::escapeString($_POST["full_name"]) . "'
                  WHERE
                     usr_id=" . Misc::escapeInteger($usr_id);
-        $res = $GLOBALS["db_api"]->dbh->query($stmt);
+        $res = Db_Helper::getInstance()->query($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return -1;
@@ -983,7 +973,7 @@
                     usr_email='" . Misc::escapeString($_POST["email"]) . "'
                  WHERE
                     usr_id=" . Misc::escapeInteger($usr_id);
-        $res = $GLOBALS["db_api"]->dbh->query($stmt);
+        $res = Db_Helper::getInstance()->query($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return -1;
@@ -1020,7 +1010,7 @@
         $stmt .= "
                  WHERE
                     usr_id=" . Misc::escapeInteger($_POST["id"]);
-        $res = $GLOBALS["db_api"]->dbh->query($stmt);
+        $res = Db_Helper::getInstance()->query($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return -1;
@@ -1030,7 +1020,7 @@
                         " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "project_user
                      WHERE
                         pru_usr_id=" . Misc::escapeInteger($_POST["id"]);
-            $res = $GLOBALS["db_api"]->dbh->query($stmt);
+            $res = Db_Helper::getInstance()->query($stmt);
             if (PEAR::isError($res)) {
                 Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
                 return -1;
@@ -1050,7 +1040,7 @@
                                 " . Misc::escapeInteger($_POST["id"]) . ",
                                 " . $role . "
                              )";
-                    $res = $GLOBALS["db_api"]->dbh->query($stmt);
+                    $res = Db_Helper::getInstance()->query($stmt);
                     if (PEAR::isError($res)) {
                         Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
                         return -1;
@@ -1096,13 +1086,13 @@
                  ) VALUES (
                     NULL,
                     NULL,
-                    '" . Date_API::getCurrentDateGMT() . "',
+                    '" . Date_Helper::getCurrentDateGMT() . "',
                     '" . Auth::hashPassword(Misc::escapeString($_POST["password"])) . "',
                     '" . Misc::escapeString($_POST["full_name"]) . "',
                     '" . Misc::escapeString($_POST["email"]) . "',
                     '" . Misc::escapeString($prefs) . "'
                  )";
-        $res = $GLOBALS["db_api"]->dbh->query($stmt);
+        $res = Db_Helper::getInstance()->query($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return -1;
@@ -1140,7 +1130,7 @@
                  ORDER BY
                     usr_status ASC,
                     usr_full_name ASC";
-        $res = $GLOBALS["db_api"]->dbh->getAll($stmt, DB_FETCHMODE_ASSOC);
+        $res = Db_Helper::getInstance()->getAll($stmt, DB_FETCHMODE_ASSOC);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return "";
@@ -1188,7 +1178,7 @@
                     usr_id
                  FROM
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "user";
-        $res = $GLOBALS["db_api"]->dbh->getAssoc($stmt);
+        $res = Db_Helper::getInstance()->getAssoc($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return "";
@@ -1215,7 +1205,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "user
                  ORDER BY
                     usr_full_name ASC";
-        $res = $GLOBALS["db_api"]->dbh->getAssoc($stmt);
+        $res = Db_Helper::getInstance()->getAssoc($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return "";
@@ -1248,7 +1238,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "user
                  WHERE
                     usr_id=" . Misc::escapeInteger($usr_id);
-        $res = $GLOBALS["db_api"]->dbh->getRow($stmt, DB_FETCHMODE_ASSOC);
+        $res = Db_Helper::getInstance()->getRow($stmt, DB_FETCHMODE_ASSOC);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return "";
@@ -1290,7 +1280,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "user
                  WHERE
                     usr_clocked_in=1";
-        $res = $GLOBALS["db_api"]->dbh->getAssoc($stmt);
+        $res = Db_Helper::getInstance()->getAssoc($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return array();
@@ -1314,7 +1304,7 @@
                     usr_clocked_in = 1
                  WHERE
                     usr_id = " . Misc::escapeInteger($usr_id);
-        $res = $GLOBALS["db_api"]->dbh->query($stmt);
+        $res = Db_Helper::getInstance()->query($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return -1;
@@ -1337,7 +1327,7 @@
                     usr_clocked_in = 0
                  WHERE
                     usr_id = " . Misc::escapeInteger($usr_id);
-        $res = $GLOBALS["db_api"]->dbh->query($stmt);
+        $res = Db_Helper::getInstance()->query($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return -1;
@@ -1361,7 +1351,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "user
                  WHERE
                     usr_id = " . Misc::escapeInteger($usr_id);
-        $res = $GLOBALS["db_api"]->dbh->getOne($stmt);
+        $res = Db_Helper::getInstance()->getOne($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return -1;
@@ -1395,7 +1385,7 @@
                     usr_grp_id = $grp_id
                  WHERE
                     usr_id = " . Misc::escapeInteger($usr_id);
-        $res = $GLOBALS["db_api"]->dbh->query($stmt);
+        $res = Db_Helper::getInstance()->query($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return -1;
@@ -1416,7 +1406,7 @@
                         " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "user
                     WHERE
                         usr_id = $usr_id";
-            $res = $GLOBALS["db_api"]->dbh->getOne($sql);
+            $res = Db_Helper::getInstance()->getOne($sql);
             if (PEAR::isError($res)) {
                 Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
                 return APP_DEFAULT_LOCALE;
@@ -1439,7 +1429,7 @@
                     usr_lang = '" . Misc::escapeString($language) . "'
                 WHERE
                     usr_id = " . Misc::escapeInteger($usr_id);
-        $res = $GLOBALS["db_api"]->dbh->query($sql);
+        $res = Db_Helper::getInstance()->query($sql);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return false;
@@ -1456,7 +1446,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "user_alias
                 WHERE
                     ual_usr_id = " . Misc::escapeInteger($usr_id);
-        $res = $GLOBALS["db_api"]->dbh->getCol($sql);
+        $res = Db_Helper::getInstance()->getCol($sql);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return array();
@@ -1482,7 +1472,7 @@
                 SET
                     ual_usr_id = " . Misc::escapeInteger($usr_id) . ",
                     ual_email = '" . Misc::escapeString($email) . "'";
-        $res = $GLOBALS["db_api"]->dbh->query($sql);
+        $res = Db_Helper::getInstance()->query($sql);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return false;
@@ -1498,7 +1488,7 @@
                 WHERE
                     ual_usr_id = " . Misc::escapeInteger($usr_id) . " AND
                     ual_email = '" . Misc::escapeString($email) . "'";
-        $res = $GLOBALS["db_api"]->dbh->query($sql);
+        $res = Db_Helper::getInstance()->query($sql);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return false;
@@ -1515,7 +1505,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "user_alias
                 WHERE
                     ual_email = '" . Misc::escapeString($email) . "'";
-        $res = $GLOBALS["db_api"]->dbh->getOne($sql);
+        $res = Db_Helper::getInstance()->getOne($sql);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return '';
--- include/class.workflow.php	2009-01-14 22:04:17.275242314 +0200
+++ /usr/share/eventum/include/class.workflow.php	2009-02-05 02:12:59.364003735 +0200
@@ -75,7 +75,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "project
                  ORDER BY
                     prj_id";
-        $res = $GLOBALS["db_api"]->dbh->getAssoc($stmt);
+        $res = Db_Helper::getInstance()->getAssoc($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return '';
@@ -104,11 +104,9 @@
                 return false;
             }
             $file_name_chunks = explode(".", $backend_class);
-            $class_name = $file_name_chunks[1] . "_Workflow_Backend";
+            $class_name = ucfirst($file_name_chunks[1]) . "_Workflow_Backend";
 
-            require_once(APP_INC_PATH . "workflow/$backend_class");
-
-            $setup_backends[$prj_id] = new $class_name;
+            $setup_backends[$prj_id] = new $class_name();
         }
         return $setup_backends[$prj_id];
     }
@@ -665,4 +663,4 @@
         $backend =& Workflow::_getBackend($prj_id);
         return $backend->getIssueFieldsToDisplay($prj_id, $issue_id, $location);
     }
-}
\ No newline at end of file
+}
--- include/customer/class.example.php	2009-01-12 23:15:11.175414194 +0200
+++ /usr/share/eventum/include/customer/class.example.php	2009-02-05 02:15:18.673989640 +0200
@@ -27,8 +27,6 @@
 // +----------------------------------------------------------------------+
 //
 
-require_once(APP_INC_PATH . "customer/class.abstract_customer_backend.php");
-require_once(APP_INC_PATH . "class.date.php");
 
 /**
  * Example customer backend. This does not cover all functionality, but should provide an idea
@@ -155,7 +153,7 @@
     {
         // active contracts have an expiration date in the future
         $expiration = strtotime($this->data[$customer_id]['expiration_date']);
-        $now = Date_API::getCurrentUnixTimestampGMT();
+        $now = Date_Helper::getCurrentUnixTimestampGMT();
         if ($expiration > $now) {
             return 'active';
         } elseif ($expiration > ($now + (DAY * $this->getExpirationOffset()))) {
@@ -343,7 +341,7 @@
                     iss_sta_id=sta_id
                  WHERE
                     iss_customer_id=$customer_id";
-        $res = $GLOBALS["db_api"]->dbh->getAssoc($stmt);
+        $res = Db_Helper::getInstance()->getAssoc($stmt);
         if ((PEAR::isError($res)) || (empty($res)) || (count($res) == 0)) {
             return array(
                 'total_issues'           => 0,
@@ -399,7 +397,7 @@
                     sbt_type='emails'
                  WHERE
                     iss_customer_id=$customer_id";
-        $res = $GLOBALS["db_api"]->dbh->getAll($stmt, DB_FETCHMODE_ASSOC);
+        $res = Db_Helper::getInstance()->getAll($stmt, DB_FETCHMODE_ASSOC);
         $persons = array();
         for ($i = 0; $i < count($res); $i++) {
             if ((!empty($res[$i]['sub_usr_id'])) && (!in_array($res[$i]['sub_usr_id'], $persons))) {
@@ -425,7 +423,7 @@
                     pru_prj_id=iss_prj_id AND
                     iss_id=$issue_id AND
                     pru_role <> " . User::getRoleID('Customer');
-        $staff_emails = $GLOBALS["db_api"]->dbh->getCol($stmt);
+        $staff_emails = Db_Helper::getInstance()->getCol($stmt);
 
         $stmt = "SELECT
                     sup_from
@@ -433,10 +431,10 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "support_email
                  WHERE
                     sup_iss_id IN (" . implode(", ", $issues) . ")";
-        $emails = $GLOBALS["db_api"]->dbh->getCol($stmt);
+        $emails = Db_Helper::getInstance()->getCol($stmt);
         $total_emails = 0;
         foreach ($emails as $address) {
-            $email = strtolower(Mail_API::getEmailAddress($address));
+            $email = strtolower(Mail_Helper::getEmailAddress($address));
             $staff_emails = array_map('strtolower', $staff_emails);
             if (@in_array($email, $staff_emails)) {
                 $total_emails++;
@@ -449,7 +447,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "phone_support
                  WHERE
                     phs_iss_id IN (" . implode(", ", $issues) . ")";
-        $calls = $GLOBALS["db_api"]->dbh->getOne($stmt);
+        $calls = Db_Helper::getInstance()->getOne($stmt);
 
         $stmt = "SELECT
                     AVG(UNIX_TIMESTAMP(iss_first_response_date) - UNIX_TIMESTAMP(iss_created_date)) AS first_response_time
@@ -457,7 +455,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "issue
                  WHERE
                     iss_id IN (" . implode(", ", $issues) . ")";
-        $avg_first_response = $GLOBALS["db_api"]->dbh->getOne($stmt);
+        $avg_first_response = Db_Helper::getInstance()->getOne($stmt);
         if (!empty($avg_first_response)) {
             // format the average into a number of minutes
             $avg_first_response = $avg_first_response / 60;
@@ -469,7 +467,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "issue
                  WHERE
                     iss_id IN (" . implode(", ", $issues) . ")";
-        $avg_close = $GLOBALS["db_api"]->dbh->getOne($stmt);
+        $avg_close = Db_Helper::getInstance()->getOne($stmt);
         if (!empty($avg_close)) {
             // format the average into a number of minutes
             $avg_close = $avg_close / 60;
@@ -707,7 +705,7 @@
         if (count($senders) > 0) {
             $emails = array();
             for ($i = 0; $i < count($senders); $i++) {
-                $emails[] = Mail_API::getEmailAddress($senders[$i]);
+                $emails[] = Mail_Helper::getEmailAddress($senders[$i]);
             }
             list($customer_id, $contact_id) = $this->getCustomerIDByEmails($emails);
             $company = $this->getDetails($customer_id);
@@ -761,7 +759,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "user
                  WHERE
                     usr_customer_contact_id = $contact_id";
-        $res = $GLOBALS["db_api"]->dbh->getRow($stmt);
+        $res = Db_Helper::getInstance()->getRow($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return -1;
--- include/custom_field/class.developer_list.php	2009-01-12 23:15:10.975419711 +0200
+++ /usr/share/eventum/include/custom_field/class.developer_list.php	2009-02-05 01:39:37.177533316 +0200
@@ -27,8 +27,6 @@
 // +----------------------------------------------------------------------+
 //
 
-require_once(APP_INC_PATH . "class.user.php");
-require_once(APP_INC_PATH . "db_access.php");
 
 
 /**
--- include/custom_field/class.dynamic.php	2009-01-12 23:15:10.975419711 +0200
+++ /usr/share/eventum/include/custom_field/class.dynamic.php	2009-02-05 01:39:37.180867399 +0200
@@ -27,8 +27,6 @@
 // +----------------------------------------------------------------------+
 //
 
-require_once(APP_INC_PATH . "class.user.php");
-require_once(APP_INC_PATH . "db_access.php");
 
 
 /**
--- include/custom_field/class.reporter_list.php	2009-01-12 23:15:10.975419711 +0200
+++ /usr/share/eventum/include/custom_field/class.reporter_list.php	2009-02-05 01:39:37.180867399 +0200
@@ -27,8 +27,6 @@
 // +----------------------------------------------------------------------+
 //
 
-require_once(APP_INC_PATH . "class.user.php");
-require_once(APP_INC_PATH . "db_access.php");
 
 
 /**
--- include/workflow/class.example.php	2009-01-12 23:15:11.298752775 +0200
+++ /usr/share/eventum/include/workflow/class.example.php	2009-02-05 02:03:28.917395227 +0200
@@ -27,7 +27,6 @@
 // +----------------------------------------------------------------------+
 //
 
-require_once(APP_INC_PATH . "workflow/class.abstract_workflow_backend.php");
 
 /**
  * Example workflow backend class. For example purposes it will print what
@@ -258,7 +257,7 @@
                     iss_percent_complete = '100%'
                 WHERE
                     iss_id = $issue_id";
-        $res = $GLOBALS["db_api"]->dbh->query($sql);
+        $res = Db_Helper::getInstance()->query($sql);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return false;
